#include <stdio.h>
#include <stdlib.h>  /* atoi() */
#include <string.h>
#include <sys/stat.h> /* mkdir() */

#define INTERVAL_SIZE 100
#define SIMPOINT_MAX 10

char *detag(char *string,char *result) {
 
   int i,out_pointer=0,in_string=0;
   
   for(i=0;i<strlen(string);i++) {
      if (string[i]=='>') {
	 in_string=1;
      }
      else if (in_string) {
         if (string[i]=='<') {	 
	    in_string=0;
	    break;
	 }
	 else {
	    result[out_pointer]=string[i];
	    out_pointer++;
	 }
      }
   }
   result[out_pointer]='\0';
   return result;
}

int main(int argc, char **argv) {
 
    char buffer[BUFSIZ],current_bench[BUFSIZ],temp[BUFSIZ],old_bench[BUFSIZ];
    char sane_bench[BUFSIZ],sane_input[BUFSIZ];
    char output[BUFSIZ];
    FILE *simpoints=NULL,*weights=NULL;
    char *result;
    int interval=0;
    double weight=0.0; 
    int seen_header=0;
    int entry_pos=0;
    int entry=0;

      /* set to be empty */
    strcpy(old_bench,"");
   
    mkdir("./alpha-simpointwebsite",S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH);
    mkdir("./alpha-simpointwebsite/atom",S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH);
    sprintf(output,"./alpha-simpointwebsite/atom/%dM",INTERVAL_SIZE);
    mkdir(output,S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH);
   
    while(1) {
       result=fgets(buffer,BUFSIZ,stdin);
       if (result==NULL) break;
       
       if (strstr(buffer,"</tr>")) {
	  if (!seen_header) {
	     seen_header=1;
	  }
	  entry_pos=0;
       }
       
       if ( (seen_header) && (strstr(buffer,"<td ")) ) {
	  
	  /* line 0 = name */
	  if (entry_pos==0) {
	     strcpy(current_bench,detag(buffer,temp));  
	     if (strcmp(current_bench,old_bench)) {
		
		if (!strcmp("ammp-ref",current_bench)) {
		   strcpy(sane_bench,"188.ammp");
		   strcpy(sane_input,"default");
		}
		else if (!strcmp("applu-ref",current_bench)) {
		   strcpy(sane_bench,"173.applu");
		   strcpy(sane_input,"default");
		}
		else if (!strcmp("apsi-ref",current_bench)) {
		   strcpy(sane_bench,"301.apsi");
		   strcpy(sane_input,"default");
		}
		else if (!strcmp("art-110",current_bench)) {
		   strcpy(sane_bench,"179.art");
		   strcpy(sane_input,"110");
		}		
		else if (!strcmp("art-470",current_bench)) {
		   strcpy(sane_bench,"179.art");
		   strcpy(sane_input,"470");
		}				
		else if (!strcmp("bzip2-graphic",current_bench)) {
		   strcpy(sane_bench,"256.bzip2");
		   strcpy(sane_input,"graphic");
		}						
		else if (!strcmp("bzip2-program",current_bench)) {
		   strcpy(sane_bench,"256.bzip2");
		   strcpy(sane_input,"program");
		}								
		else if (!strcmp("bzip2-source",current_bench)) {
		   strcpy(sane_bench,"256.bzip2");
		   strcpy(sane_input,"source");
		}
		else if (!strcmp("crafty-ref",current_bench)) {
		   strcpy(sane_bench,"186.crafty");
		   strcpy(sane_input,"default");
		}
		else if (!strcmp("eon-cook",current_bench)) {
		   strcpy(sane_bench,"252.eon");
		   strcpy(sane_input,"cook");
		}		
		else if (!strcmp("eon-kajiya",current_bench)) {
		   strcpy(sane_bench,"252.eon");
		   strcpy(sane_input,"kajiya");
		}				
		else if (!strcmp("eon-rushmeier",current_bench)) {
		   strcpy(sane_bench,"252.eon");
		   strcpy(sane_input,"rushmeier");
		}				
		else if (!strcmp("equake-ref",current_bench)) {
		   strcpy(sane_bench,"183.equake");
		   strcpy(sane_input,"default");
		}						
		else if (!strcmp("facerec-ref",current_bench)) {
		   strcpy(sane_bench,"187.facerec");
		   strcpy(sane_input,"default");
		}
		else if (!strcmp("fma3d-ref",current_bench)) {
		   strcpy(sane_bench,"191.fma3d");
		   strcpy(sane_input,"default");
		}
		else if (!strcmp("galgel-ref",current_bench)) {
		   strcpy(sane_bench,"178.galgel");
		   strcpy(sane_input,"default");
		}		
		else if (!strcmp("gap-ref",current_bench)) {
		   strcpy(sane_bench,"254.gap");
		   strcpy(sane_input,"default");
		}
		else if (!strcmp("gcc-166",current_bench)) {
		   strcpy(sane_bench,"176.gcc");
		   strcpy(sane_input,"166");
		}						
		else if (!strcmp("gcc-200",current_bench)) {
		   strcpy(sane_bench,"176.gcc");
		   strcpy(sane_input,"200");
		}
		else if (!strcmp("gcc-expr",current_bench)) {
		   strcpy(sane_bench,"176.gcc");
		   strcpy(sane_input,"expr");
		}
		else if (!strcmp("gcc-integrate",current_bench)) {
		   strcpy(sane_bench,"176.gcc");
		   strcpy(sane_input,"integrate");
		}		
		else if (!strcmp("gcc-scilab",current_bench)) {
		   strcpy(sane_bench,"176.gcc");
		   strcpy(sane_input,"scilab");
		}
		else if (!strcmp("gzip-graphic",current_bench)) {
		   strcpy(sane_bench,"164.gzip");
		   strcpy(sane_input,"graphic");
		}		
		else if (!strcmp("gzip-log",current_bench)) {
		   strcpy(sane_bench,"164.gzip");
		   strcpy(sane_input,"log");
		}
		else if (!strcmp("gzip-program",current_bench)) {
		   strcpy(sane_bench,"164.gzip");
		   strcpy(sane_input,"program");
		}		
		else if (!strcmp("gzip-random",current_bench)) {
		   strcpy(sane_bench,"164.gzip");
		   strcpy(sane_input,"random");
		}
		else if (!strcmp("gzip-source",current_bench)) {
		   strcpy(sane_bench,"164.gzip");
		   strcpy(sane_input,"source");
		}
		else if (!strcmp("lucas-ref",current_bench)) {
		   strcpy(sane_bench,"189.lucas");
		   strcpy(sane_input,"default");
		}		
		else if (!strcmp("mcf-ref",current_bench)) {
		   strcpy(sane_bench,"181.mcf");
		   strcpy(sane_input,"default");
		}				
		else if (!strcmp("mesa-ref",current_bench)) {
		   strcpy(sane_bench,"177.mesa");
		   strcpy(sane_input,"default");
		}
		else if (!strcmp("mgrid-ref",current_bench)) {
		   strcpy(sane_bench,"172.mgrid");
		   strcpy(sane_input,"default");
		}
		else if (!strcmp("parser-ref",current_bench)) {
		   strcpy(sane_bench,"197.parser");
		   strcpy(sane_input,"default");
		}		
		else if (!strcmp("perlbmk-diffmail",current_bench)) {
		   strcpy(sane_bench,"253.perlbmk");
		   strcpy(sane_input,"diffmail");
		}		
		else if (!strcmp("perlbmk-makerand",current_bench)) {
		   strcpy(sane_bench,"253.perlbmk");
		   strcpy(sane_input,"makerand");
		}
		else if (!strcmp("perlbmk-perfect",current_bench)) {
		   strcpy(sane_bench,"253.perlbmk");
		   strcpy(sane_input,"perfect");
		}
		else if (!strcmp("perlbmk-splitmail",current_bench)) {
		   strcpy(sane_bench,"253.perlbmk");
		   strcpy(sane_input,"splitmail");
		}
		else if (!strcmp("sixtrack-ref",current_bench)) {
		   strcpy(sane_bench,"200.sixtrack");
		   strcpy(sane_input,"default");
		}		
		else if (!strcmp("swim-ref",current_bench)) {
		   strcpy(sane_bench,"171.swim");
		   strcpy(sane_input,"default");
		}
		else if (!strcmp("twolf-ref",current_bench)) {
		   strcpy(sane_bench,"300.twolf");
		   strcpy(sane_input,"default");
		}						
		else if (!strcmp("vortex-one",current_bench)) {
		   strcpy(sane_bench,"255.vortex");
		   strcpy(sane_input,"1");
		}
		else if (!strcmp("vortex-two",current_bench)) {
		   strcpy(sane_bench,"255.vortex");
		   strcpy(sane_input,"2");
		}		
		else if (!strcmp("vortex-three",current_bench)) {
		   strcpy(sane_bench,"255.vortex");
		   strcpy(sane_input,"3");
		}
		else if (!strcmp("vpr-route",current_bench)) {
		   strcpy(sane_bench,"175.vpr");
		   strcpy(sane_input,"route");
		}
		else if (!strcmp("wupwise-ref",current_bench)) {
		   strcpy(sane_bench,"168.wupwise");
		   strcpy(sane_input,"default");
		}		
		else {
		   printf("Unknown bench %s\n",current_bench);
		   exit(-1);
		}

		strcpy(old_bench,current_bench);
		   /* close old files, if appropriate */
		if (simpoints!=NULL) fclose(simpoints);
		if (weights!=NULL) fclose(weights);		
		sprintf(output,"./alpha-simpointwebsite/atom/%dM/%s.static.%s.pre.fast",
			INTERVAL_SIZE,sane_bench,sane_input);
		mkdir(output,S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH);
		sprintf(output,"./alpha-simpointwebsite/atom/%dM/%s.static.%s.pre.fast/%s.static.%s.pre.fast.simpoints.%d",
			INTERVAL_SIZE,sane_bench,sane_input,sane_bench,sane_input,SIMPOINT_MAX);		
		simpoints=fopen(output,"w");
		if (simpoints==NULL) {
		   printf("Cannot open %s\n",output);
		   exit(-1);
		}
		sprintf(output,"./alpha-simpointwebsite/atom/%dM/%s.static.%s.pre.fast/%s.static.%s.pre.fast.weights.%d",
			INTERVAL_SIZE,sane_bench,sane_input,sane_bench,sane_input,SIMPOINT_MAX);		
		weights=fopen(output,"w");
		if (weights==NULL) {
		   printf("Cannot open %s\n",output);
		   exit(-1);
		}
		entry=0;
		
	     }
	  }
	  /* line 1 = simpoint */
	  if (entry_pos==1) {
	     detag(buffer,temp);	     
	     interval=atoi(temp);
	     fprintf(simpoints,"%d %d\n",interval,entry);
	  }
	  /* line 2 = weight */
	  if (entry_pos==2) {
	     detag(buffer,temp);
	     weight=atof(temp);
	     fprintf(weights,"%lf %d\n",weight,entry);
	  }
	  /* line 3 = PC */
	  if (entry_pos==3) {
	  }	  
	  /* line 4 = PC count */
	  if (entry_pos==4) {
//	     printf("%d %lf\n",interval,weight);
	     entry++;
	  }
	  entry_pos++;
	  if (entry_pos>4) entry_pos=0;
       }
       
       
    }
  if (simpoints!=NULL) fclose(simpoints);
  if (weights!=NULL) fclose(weights);			     

   
   return 0;
}
